CleanCombat = LibStub("AceAddon-3.0"):NewAddon("CleanCombat", "AceConsole-3.0", "AceEvent-3.0")


local defaults = {
    profile = {
        enabled = true,
        ptframes = false,
        buffframes = false,
        chat_opacity = 1,
        mcalpha_toggle = false,
        mcalpha_opacity = 1,
        otalpha_toggle = false,
        otalpha_opacity = 1,
        gametooltip_toggle = false,
        gametooltip_opacity = 1,
        debug_mode = false,
    },
}




local options = { 
    name = "CleanCombat",
    handler = CleanCombat,
    type = "group",
    args = {
        enabled = {
            type = "toggle",
            name = "Enable",
            desc = "Enable / disable the AddOn",
            get = "IsEnabled",
            set = "ToggleEnabled",
        },
        
        
        general = {
			type = "group",
			name = "General",
			desc = "Settings that do not affect any specific part of the addon",
			order = 1,
            args = {
                
                general_header = {
                    type = "header",
                    name = "General Settings",
                    order = 1,
                },
        
        
        
                ptframes = {
                    type = "toggle",
                    order = 2,
                    name = "Hide Player/Target",
                    desc = "Hide the Player and target Frames",
                    get = "ptFrames",
                    set = "ToggleptFrames",
                },
                
                
                buffframes = {
                    type = "toggle",
                    order = 3,
                    name = "Position Buff Frames",
                    desc = "[UNFINISHED!]Change the position of buff frames to below the player frame while in combat",
                    get = function(info) return db.profile.buffframes end,
                    set = function(info, input) db.profile.buffframes = input end,
                },
                
                chat_opacity = {
					type = "range",
                    order = 4,
					name = "Chat Opacity",
					desc = "The opacity of the chat in combat. 1 = fully visible.",
					min = 0, max = 1, step = 0.01,
                    set = function(info, input) db.profile.chat_opacity = input end,
			        get = function(info) return db.profile.chat_opacity end,
				},
                
                
                debug_mode = {
                    type = "toggle",
                    order = 5,
                    name = "[Debug]",
                    desc = "Reports variables as chat messages for debugging purposes",
                    get = function(info) return db.profile.debug_mode end,
                    set = function(info, input) db.profile.debug_mode = input end,
                },
                
            },
        },
        
        minimap = {
			type = "group",
			name = "Minimap Cluster",
			desc = "Adjust how Clean Combat modifies the Minimap Cluster",
			order = 2,
            args = {
                
                minimap_header = {
                    type = "header",
                    name = "Minimap Settings",
                    order = 1,
                },
        
                mcalpha_toggle = {
                    type = "toggle",
                    name = "Fade",
                    desc = "Reduce the opacity of the minimap cluster instead of hiding it",
                    get = "McAlphaEnabled",
                    set = "ToggleMcAlpha",
                    order = 2,
                },
                
                mcalpha_opacity = {
					type = "range",
                    order = 3,
					name = "Minimap Cluster Opacity",
					desc = "The opacity of the minimap in combat",
					min = 0, max = 1, step = 0.01,
                    set = function(info, input) db.profile.mcalpha_opacity = input end,
			        get = function(info) return db.profile.mcalpha_opacity end
				},

            },
        },
        
        
        objectives_tracker = {
			type = "group",
			name = "Objective Tracker",
			desc = "Adjust how Clean Combat modifies the Objective Tracker",
			order = 3,
            args = {
            
                objectivetracker_header = {
                    type = "header",
                    name = "Objective Tracker Settings",
                    order = 1,
                },
        
                otalpha_toggle = {
                    type = "toggle",
                    name = "Fade",
                    desc = "Reduce the opacity of the Objective Tracker instead of hiding it",
                    get = "OtAlphaEnabled",
                    set = "ToggleOtAlpha",
                    order = 2,
                },
                
                otalpha_opacity = {
					type = "range",
                    order = 3,
					name = "Objective Tracker Opacity",
					desc = "The opacity of the Objective Tracker in combat",
					min = 0, max = 1, step = 0.01,
                    set = function(info, input) db.profile.otalpha_opacity = input end,
			        get = function(info) return db.profile.otalpha_opacity end
				},

            },
        },
        
        --[[
        gametooltip = {
			type = "group",
			name = "Game Tooltip",
			desc = "Adjust how Clean Combat modifies the bottom right tooltip",
			order = 4,
            args = {
                
                gametooltip_header = {
                    type = "header",
                    name = "Game Tooltip Settings",
                    order = 1,
                },
        
                gametooltip_toggle = {
                    type = "toggle",
                    name = "Fade",
                    desc = "Reduce the opacity of the game tooltip instead of hiding it",
                    get = function(info) return db.profile.gametooltip_toggle end,
                    set = function(info, input) db.profile.gametooltip_toggle = input end,
                    order = 2,
                },
                
                gametooltip_opacity = {
					type = "range",
                    order = 3,
					name = "Game Tooltip Opacity",
					desc = "The opacity of the game tooltip in combat",
					min = 0, max = 1, step = 0.01,
                    set = function(info, input) db.profile.gametooltip_toggle = input end,
			        get = function(info) return db.profile.gametooltip_toggle end,
				},

            },
        },
        
        ]]--
        
        about_page = {
			type = "group",
			name = "About",
			order = 4,
            args = {

                about_header = {
                    type = "header",
                    name = "About Clean Combat",
                    order = 1,
                },

                about_text1 = {
                    type = "description",
                    name = "Created by Veniru - Silvermoon EU",
                    fontSize = "medium",
                    order = 2,
                },
                
                about_text2 = {
                    type = "description",
                    name = "For issues and more information visit the Curse Website of this AddOn",
                    fontSize = "medium",
                    order = 3,
                },
                
                about_text3 = {
                    type = "description",
                    name = "Or contact me directly on Discord @: Veniru#1815",
                    fontSize = "medium",
                    order = 4,
                },

            },
        }, 
    },
}






local f=CreateFrame("Frame");
local mc=MinimapCluster; -- Minimap
local qot=ObjectiveTrackerFrame; -- Quest Objective Tracker
--local gtt=GameTooltip; -- Hover tooltip info
local bff=BuffFrame;
local chat=ChatFrame1;
local tf=TargetFrame;



function hidePTFrames()
    PlayerFrame:Hide()
    TargetFrame:Hide()
    tf:ClearAllPoints()
    tf:SetPoint("Top",PlayerFrame,"Top", 0, -5000)
    tf:Hide()
end






function CleanCombat:OnInitialize()
    -- Called when the addon is loaded
    db = LibStub("AceDB-3.0"):New("CleanCombatDB", defaults, true)
    if db.profile.debug_mode then
        CleanCombat:Print(db:GetCurrentProfile())
    end

    LibStub("AceConfig-3.0"):RegisterOptionsTable("CleanCombat", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("CleanCombat", "Clean Combat")
    if db.profile.enabled then
        CleanCombat:Enable()
    end
end

-- Overall addon --
function CleanCombat:IsEnabled(info)
    return db.profile.enabled
end


function CleanCombat:ToggleEnabled(info, value)
    db.profile.enabled = value
    CleanCombat:Print(db.profile.enabled);
    
    if db.profile.enabled then
        CleanCombat:Enable()
    else
        CleanCombat:Disable()
    end
    
end




-- MC Alpha Toggle --
function CleanCombat:McAlphaEnabled(info)
    return db.profile.mcalpha_toggle
end


function CleanCombat:ToggleMcAlpha(info, value)
    db.profile.mcalpha_toggle = value
end



-- MC Alpha Pass --
function McAlphaSet(info)
    db.profile.mcalpha_opacity = mcAlpha
end





-- OT Alpha Toggle --
function CleanCombat:OtAlphaEnabled(info)
    return db.profile.otalpha_toggle
end


function CleanCombat:ToggleOtAlpha(info, value)
    db.profile.otalpha_toggle = value
end

-- Player Target Frame Hide --
function CleanCombat:ptFrames(info)
    return db.profile.ptframes
end


function CleanCombat:ToggleptFrames(info, value)
    if db.profile.enabled then
        db.profile.ptframes = value

        if db.profile.ptframes then
            hidePTFrames()
            if db.profile.debug_mode then
                CleanCombat:Print("Ptframes check works")
            end
            
        else
            PlayerFrame:ClearAllPoints() 
            PlayerFrame:SetPoint("CENTER",UIParent,-200,-50)
            PlayerFrame:Show()

            TargetFrame:ClearAllPoints() 
            TargetFrame:SetPoint("CENTER",UIParent,200,-50)
            TargetFrame:Show()
        end
    else
        CleanCombat:Print("You need to enable Clean Combat first!")
    end
end













function CleanCombat:OnEnable()
    if db.profile.enabled then
        if db.profile.ptframes then
            hidePTFrames()
        end

        f:SetScript("OnEvent",function(self,event)
                -- Set everything to show just in case -- 
         if event=="PLAYER_ENTERING_WORLD" then
                    mc.Show()
                    qot:Show()
                    chat:SetAlpha(1)
         elseif event=="PLAYER_REGEN_DISABLED" then
                    -- DEBUG MODE REPORTS --
                    if db.profile.debug_mode then
                        CleanCombat:Print("--- Entering Combat ---")
                        CleanCombat:Print(db.profile.ptframes)
                        CleanCombat:Print(db.profile.buffframes)
                        CleanCombat:Print(db.profile.chat_opacity)
                        CleanCombat:Print(db.profile.mcalpha_toggle)
                        CleanCombat:Print(db.profile.mcalpha_opacity)
                        CleanCombat:Print(db.profile.otalpha_toggle)
                        CleanCombat:Print(db.profile.otalpha_opacity)
                        CleanCombat:Print(db.profile.gametooltip_toggle)
                        CleanCombat:Print(db.profile.gametooltip_opacity)
                    end
                    
                    
                    -- Minimap Cluster Alpha Check --
                    if db.profile.mcalpha_toggle then
                        mc:SetAlpha(db.profile.mcalpha_opacity)
                    elseif not db.profile.mcalpha_toggle then  
                        mc:Hide()
                    end
                    
                    -- Objective Tracker Alpha Check --
                    if db.profile.otalpha_toggle then
                        qot:SetAlpha(db.profile.otalpha_opacity)
                    elseif not db.profile.otalpha_toggle then  
                        qot:Hide()
                    end
                    
                    -- Hide The Game Tooltip if the player happens to be targeting anything right now --
                    --gtt:Hide()
                    
                    
                    -- Buff Frames Move Check --
                    if db.profile.buffframes then
                        bff:ClearAllPoints()
                        bff:SetScale(0.8)
                        bff:SetPoint("Right",PlayerFrame,"RIGHT", 300, 35)
                    end
                    
                    -- Player Frame Hide Check --
                    if db.profile.ptframes then
                        tf:ClearAllPoints()
                        tf:SetPoint("Top",PlayerFrame,"Top", 0, -9999)
                        tf:Hide()
                    end
                    
                    chat:SetAlpha(db.profile.chat_opacity)
                    
                    
         elseif event=="PLAYER_REGEN_ENABLED" then
                    
                    if db.profile.debug_mode then
                        CleanCombat:Print("--- Exiting Combat ---")
                    end
                    
                    -- Reset Everything When Leaving Combat --
                    mc:Show()
                    mc:SetAlpha(1)
                    qot:Show()
                    qot:SetAlpha(1)
                    bff:ClearAllPoints()
                    bff:SetScale(1)
                    bff:SetPoint("TOPRIGHT",UIParent, -200, -10)
                    chat:SetAlpha(1)
            
        elseif event=="PLAYER_TARGET_CHANGED" then
                   --[[ -- Modify The Game Tooltip On Change --
                    if db.profile.gametooltip_toggle then
                        gtt:SetAlpha(db.profile.gametooltip_opacity)
                    elseif not db.profile.gametooltip_toggle then  
                        gtt:Hide()
                    end
                    ]]--
         end
        end)


        f:RegisterEvent("PLAYER_ENTERING_WORLD")
        f:RegisterEvent("PLAYER_REGEN_DISABLED")
        f:RegisterEvent("PLAYER_REGEN_ENABLED")
        f:RegisterEvent("PLAYER_TARGET_CHANGED")
        if db.profile.debug_mode then
            CleanCombat:Print("Addon Successfully Enabled")
        end
    end
end

function CleanCombat:OnDisable()
    if not db.profile.enabled then
        mc:Show()
        qot:Show()
        gtt:Show()
        bff:ClearAllPoints()
        bff:SetScale(1)
        bff:SetPoint("TOPRIGHT",UIParent, -200, -10)
        chat:SetAlpha(1)
        f:UnregisterAllEvents()
        PlayerFrame:Show()
    end
end 